/***************************************************************************
 *   Copyright (C) 2003,2004 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// #include <sys/types.h>
// #include <dirent.h>
// #include <unistd.h>
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "interface.h"
#include "chmsee_config.h"

void chmsee_init_config_path(ChmSee *window) {
	
	gchar	*chmsee_home;

	chmsee_home = g_strdup_printf("%s/%s",g_get_home_dir(), ".chmsee");

	if (!g_file_test (chmsee_home, G_FILE_TEST_IS_DIR)) {
		mkdir(chmsee_home, 0777);
	}

	window->last_dir = g_strdup_printf("%s/%s",chmsee_home, "chmsee_lastdir");
	window->bookmarks = g_strdup_printf("%s/%s",chmsee_home, "chmsee_bookmark");
	window->last_chm = g_strdup_printf("%s/%s",chmsee_home, "chmsee_lastchm");
	window->config = g_strdup_printf("%s/%s",chmsee_home, "chmsee_config");
	g_print("Initializer Done\n");
}

void chmsee_load_last_chm_file()
{

}

void chmsee_save_last_chm_file()
{

}

void chmsee_load_config (ChmSee *window)
{
	FILE	*fp;
	gchar	*get_tmp;
	gchar	*tmp_always;
	gchar	*ch;
	gint	label = 0;
	char	lineBuf[256];

	window->is_always = 0;
	window->current_codeset = "UTF-8";

	fp = fopen(window->config, "r");
	
	if (!fp) {
		chmsee_save_config(window);
		return;
	}
	
	while(fgets(lineBuf,512,fp)!=NULL) {
		
		if (( ch = g_strrstr (lineBuf,"ALWAYSUSE="))) {
			
			get_tmp = g_strdup( ch + 10);
			tmp_always = g_strndup(get_tmp, strlen(get_tmp)-1);
			window->is_always = atoi(tmp_always);
			label = 1;
		} else if ((ch = g_strrstr(lineBuf, "CHARSET="))) {
			
			get_tmp = g_strdup(ch + 8);
			window->current_codeset = g_strndup(get_tmp, strlen(get_tmp)-1);
			label = 2;
		}
	}
	
	fclose(fp);
	
	if (label == 0) {
		chmsee_save_config(window);
	}
}

void chmsee_save_config (ChmSee *window)
{
	FILE	*file;
	gchar	*s;
	gchar	*p;

	file = fopen(window->config, "w");
	s = g_strdup_printf("ALWAYSUSE=%d\n", window->is_always);
	p = g_strdup_printf("CHARSET=%s\n", window->current_codeset);
	fprintf(file, s);
	fprintf(file, p);
	fclose(file);
	
}

gchar *
chmsee_load_last_chm_dir(ChmSee *window)
{
	gchar	*get_dir = NULL;
	
	if (!g_file_test (window->last_dir, G_FILE_TEST_EXISTS)) {
		return (get_dir);
	}

	FILE	*fp;
	char	lineBuf[256];
	
	fp = fopen(window->last_dir, "r");
	
	if (!fp) {
		return (get_dir);
	}
	
	while(fgets(lineBuf,512,fp)!=NULL) {
		
		get_dir = g_strdup_printf("%s/", lineBuf);
	}
	
	fclose(fp);
	return (get_dir);
}

void chmsee_save_last_chm_dir(ChmSee *window, gchar *path)
{
	FILE	*file;
	
	file = fopen(window->last_dir, "w");
	fprintf(file, path);
	fclose(file);
}
