
#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

typedef struct _ChmSee ChmSee;

struct _ChmSee {

	/* default window */
	GtkWidget	*chmsee_window;
	
	/* toolbar */
	GtkWidget	*chmsee_toolbar_back;
	GtkWidget	*chmsee_toolbar_search;
	GtkWidget	*chmsee_toolbar_forward;
	GtkWidget	*chmsee_toolbar_home;
	GtkWidget	*chmsee_toolbar_small;
	GtkWidget	*chmsee_toolbar_big;
	GtkWidget	*chmsee_toolbar_reset;
	GtkWidget	*chmsee_toolbar_showw;
	
	/* notebook */
	GtkWidget	*chm_pw;
	GtkWidget	*nb_entry;
	GtkWidget	*nb_button_contnts;

	/* Contents */
	GtkWidget	*chm_tree;
	
	/* bookmark */
	GtkWidget	*nb_bookmark_treeview;
	GtkWidget	*nb_bookmark_entry;
	GtkWidget	*nb_button_bookmark_add;
	gchar		*bookmark_title;
	const gchar	*bookmark_uri;
	gchar		*bookmark_id;
	
	/* htmlview */
	GtkWidget	*chm_html;
	GList		*link;
	guint		link_pos;
	gchar		*current_link;
	gchar		*home_url;
	const gchar	*hhc_name;
	const gchar *current_codeset;
	const gchar	*lang_set;
	
	/* charset */
	GtkWidget	*chmsee_char_treeview;
	GtkWidget	*chmsee_char_checkbtn;
	gint		is_always;
	
	/* other */
	gchar		*tmpdir;
	gchar		*last_dir;
	gchar		*bookmarks;
	gchar		*last_chm;
	gchar		*config;
	const gchar	*chm_name;
};

enum {
	TITLE_COLUMN,
	FILENAME_COLUMN,
	ID_COLUMN,
	NUM_COLUMNS
};

void create_main_window (ChmSee *window);

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#endif /* __INTERFACE_H__ */
