/***************************************************************************
 *   Copyright (C) 2003 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <gtk/gtk.h>
#include "interface.h"
#include "startup.h"
#include "charset.h"
#include "chmsee_config.h"
#include "callbacks.h"


int
main (int argc, char *argv[])
{
	const gchar *filename = NULL;
	
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);

  	gtk_set_locale ();

	if (!g_thread_supported()) g_thread_init(NULL);

  	gtk_init (&argc, &argv);

	ChmSee *window;
	window = g_new0(ChmSee, 1);

	if (argv[1]) {
		filename = g_strdup_printf("%s", argv[1]);
	}


	chmsee_init_config_path(window);
	chmsee_load_config(window);	
	create_main_window (window);
	chmsee_init(window);

	if (filename) {

		window->chm_name = g_strdup_printf("%s", filename);
		
		if (window->is_always == 1) {
			chmsee_startup_popup_new();
			chmsee_go_ex_chm_file(window, window->chm_name);
		} else {
			chmsee_char_dialog_new (window);
		}
	}

	gtk_widget_show(window->chmsee_window);

  	gtk_main ();

	command_delete_tmpdir(window->tmpdir);
	g_free(window);
  	return 0;
}
