/***************************************************************************
 *   Copyright (C) 2003 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <gtk/gtk.h>
#include "interface.h"
#include "html.h"
#include "bookmarks.h"

/*
static void chmsee_html_reload_to_gbk(ChmSee *window);
static void chmsee_html_reload_to_gb18030(ChmSee *window);
static void chmsee_html_reload_to_gb2312(ChmSee *window);
static void chmsee_html_reload_to_big5(ChmSee *window);
static void chmsee_html_reload_to_hz(ChmSee *window);
static void chmsee_html_reload_to_iso(ChmSee *window);
static void chmsee_html_reload_to_window(ChmSee *window);
static void chmsee_html_reload_to_none(ChmSee *window);

static void
chmsee_html_reload_to_gbk(ChmSee *window)
{
	window->current_codeset = "GBK";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_gb18030(ChmSee *window)
{
	window->current_codeset = "GB18030";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_gb2312(ChmSee *window)
{
	window->current_codeset = "GB2312";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_big5(ChmSee *window)
{
	window->current_codeset = "BIG5";
	chmsee_html_reload (window, window->current_link);
	
}

static void
chmsee_html_reload_to_hz(ChmSee *window)
{
	window->current_codeset = "ISO-8859-1";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_iso(ChmSee *window)
{
	window->current_codeset = "ISO-8859-15";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_window(ChmSee *window)
{
	window->current_codeset = "Windows-1252";
	chmsee_html_reload (window, window->current_link);
}

static void
chmsee_html_reload_to_none(ChmSee *window)
{
	window->current_codeset = "NONE";
	chmsee_html_reload (window, window->current_link);
	
}

void chmsee_menu_popup (GdkEventButton *event, ChmSee *window) 
{
	GtkWidget	*menu;
	GtkWidget	*menu_name;
	GtkWidget	*menu_gb18030;
	GtkWidget	*menu_gb2312;
	GtkWidget	*menu_gbk;
	GtkWidget	*menu_big5;
	GtkWidget	*menu_hz;
	GtkWidget	*menu_iso;
	GtkWidget	*menu_window;
	GtkWidget	*menu_none;
	GtkWidget	*menu_separator;
	GtkWidget	*menu_separator2;
	GtkWidget	*menu_bookmark_add;

	menu = gtk_menu_new ();
	
	menu_name = gtk_menu_item_new_with_label ("设置编码");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_name);
	gtk_widget_show (menu_name);
	gtk_widget_set_sensitive (menu_name, FALSE);
	
	menu_separator = gtk_separator_menu_item_new ();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_separator);
	gtk_widget_show (menu_separator);
	gtk_widget_set_sensitive (menu_separator, FALSE);

	menu_gb18030 = gtk_menu_item_new_with_label ("简体中文(GB18030)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gb18030);
    g_signal_connect_swapped (G_OBJECT (menu_gb18030), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_gb18030), 
                              window);
	gtk_widget_show (menu_gb18030);

	menu_gb2312 = gtk_menu_item_new_with_label ("简体中文(GB2312)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gb2312);
    g_signal_connect_swapped (G_OBJECT (menu_gb2312), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_gb2312), 
                              window);
	gtk_widget_show (menu_gb2312);

	menu_gbk = gtk_menu_item_new_with_label ("简体中文(GBK)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gbk);
    g_signal_connect_swapped (G_OBJECT (menu_gbk), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_gbk), 
                              window);
	gtk_widget_show (menu_gbk);

	menu_big5 = gtk_menu_item_new_with_label ("繁体中文(BIG5)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_big5);
    g_signal_connect_swapped (G_OBJECT (menu_big5), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_big5), 
                              window);
	gtk_widget_show (menu_big5); 

	menu_hz = gtk_menu_item_new_with_label ("西方英文(ISO-8859-1)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_hz);
    g_signal_connect_swapped (G_OBJECT (menu_hz), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_hz), 
                              window);
	gtk_widget_show (menu_hz);
	
	menu_iso = gtk_menu_item_new_with_label ("西方英文(ISO-8859-15)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_iso);
    g_signal_connect_swapped (G_OBJECT (menu_iso), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_iso), 
                              window);
	gtk_widget_show (menu_iso);

	menu_window = gtk_menu_item_new_with_label ("西方英文(Windows-1252)");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_window);
    g_signal_connect_swapped (G_OBJECT (menu_window), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_window), 
                              window);
	gtk_widget_show (menu_window);

	menu_none = gtk_menu_item_new_with_label ("不转换原编码");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_none);
    g_signal_connect_swapped (G_OBJECT (menu_none), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_none), 
                              window);
	gtk_widget_show (menu_none);
	
	menu_separator2 = gtk_separator_menu_item_new ();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_separator2);
	gtk_widget_show (menu_separator2);
	gtk_widget_set_sensitive (menu_separator2, FALSE);
	
	menu_bookmark_add = gtk_menu_item_new_with_label ("将本页加入书签");
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_bookmark_add);
    g_signal_connect (G_OBJECT (menu_bookmark_add), "activate",
		              G_CALLBACK (chmsee_html_bookmark_add), 
                      window);

	gtk_widget_show (menu_bookmark_add);
	
	gtk_menu_popup (GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button, event->time);

}
*/

static ChmSee *menu_codeset;

static gchar *code_var[] = {
	"GB18030",
	"GB2312",
	"GBK",
	"BIG5",
	"ISO-8859-1",
	"ISO-8859-15",
	"Windows-1252",
	"Shift-JIS",
	"NONE"
};

static void
chmsee_html_reload_to_setcode(GtkWidget *widget, gchar *codeset)
{

	menu_codeset->lang_set = g_strdup_printf("%s", codeset);
	g_print("current ->[%s]\n", codeset);
	chmsee_html_reload (menu_codeset, menu_codeset->current_link);
}

void chmsee_menu_popup (GdkEventButton *event, ChmSee *window) 
{
	GtkWidget	*menu;
	GtkWidget	*menu_name;
	GtkWidget	*menu_gb18030;
	GtkWidget	*menu_gb2312;
	GtkWidget	*menu_gbk;
	GtkWidget	*menu_big5;
	GtkWidget	*menu_hz;
	GtkWidget	*menu_iso;
	GtkWidget	*menu_window;
	GtkWidget	*menu_jp;
	GtkWidget	*menu_none;
	GtkWidget	*menu_separator;
	GtkWidget	*menu_separator2;
	GtkWidget	*menu_bookmark_add;

	menu_codeset = window;

	menu = gtk_menu_new ();
	
	menu_name = gtk_menu_item_new_with_label (_("Encoding"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_name);
	gtk_widget_show (menu_name);
	gtk_widget_set_sensitive (menu_name, FALSE);
	
	menu_separator = gtk_separator_menu_item_new ();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_separator);
	gtk_widget_show (menu_separator);
	gtk_widget_set_sensitive (menu_separator, FALSE);

	menu_gb18030 = gtk_menu_item_new_with_label (_("Simplified Chinese (GB18030)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gb18030);
    g_signal_connect (G_OBJECT (menu_gb18030), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[0]);
	gtk_widget_show (menu_gb18030);

	menu_gb2312 = gtk_menu_item_new_with_label (_("Simplified Chinese (GB2312)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gb2312);
    g_signal_connect (G_OBJECT (menu_gb2312), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[1]);
	gtk_widget_show (menu_gb2312);

	menu_gbk = gtk_menu_item_new_with_label (_("Simplified Chinese (GBK)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_gbk);
    g_signal_connect (G_OBJECT (menu_gbk), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[2]);
	gtk_widget_show (menu_gbk);

	menu_big5 = gtk_menu_item_new_with_label (_("Traditional Chinese (Big5)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_big5);
    g_signal_connect (G_OBJECT (menu_big5), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[3]);
	gtk_widget_show (menu_big5); 

	menu_hz = gtk_menu_item_new_with_label (_("Western (ISO-8859-1)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_hz);
    g_signal_connect (G_OBJECT (menu_hz), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[4]);
	gtk_widget_show (menu_hz);
	
	menu_iso = gtk_menu_item_new_with_label (_("Western (ISO-8859-15)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_iso);
    g_signal_connect (G_OBJECT (menu_iso), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[5]);
	gtk_widget_show (menu_iso);

	menu_window = gtk_menu_item_new_with_label (_("Western (Windows-1252)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_window);
    g_signal_connect (G_OBJECT (menu_window), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[6]);
	gtk_widget_show (menu_window);
	
	menu_jp = gtk_menu_item_new_with_label (_("Japanese (Shift-JIS)"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_jp);
    g_signal_connect (G_OBJECT (menu_jp), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[7]);
	gtk_widget_show (menu_jp);

	menu_none = gtk_menu_item_new_with_label (_("Original Encoding"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_none);
    g_signal_connect (G_OBJECT (menu_none), "activate",
		                      G_CALLBACK (chmsee_html_reload_to_setcode), 
                              code_var[8]);
	gtk_widget_show (menu_none);
	
	menu_separator2 = gtk_separator_menu_item_new ();
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_separator2);
	gtk_widget_show (menu_separator2);
	gtk_widget_set_sensitive (menu_separator2, FALSE);
	
	menu_bookmark_add = gtk_menu_item_new_with_label (_("add to bookmark"));
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_bookmark_add);
    g_signal_connect (G_OBJECT (menu_bookmark_add), "activate",
		              G_CALLBACK (chmsee_html_bookmark_add), 
                      window);

	gtk_widget_show (menu_bookmark_add);
	
	gtk_menu_popup (GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button, event->time);

}
